#!/usr/bin/env python

import threading
import socket
import sys
import urllib

def execute( commands, host = "localhost", port = 45537 ):
	result = "OK"
	if len( commands ) > 0:
		cmd = ""
		for i in commands:
			cmd += urllib.quote( i ) + " "
		s = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
		try:
			s.connect( ( host, port ) )
			s.send( "text: " + str( len( cmd ) ) + "\n" )
			s.send( cmd )
			result = s.recv( 1024 )
			s.close( )
		except Exception, e:
			result = str( e )
	return result

class status( threading.Thread ):
	def __init__( self, status_cb, host = "localhost", port = 45537 ):
		threading.Thread.__init__( self )
		self.setDaemon( True )
		self.status_cb = status_cb
		self.host = host
		self.port = port
		self.start( )
	
	def run( self ):
		s = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
		try:
			s.connect( ( self.host, self.port ) )
			s.send( "status\n" )
			data = s.recv( 1024 )
			while data != "" and data != "OK":
				stuff = data.split( " " )
				if len( stuff ) == 2:
					self.status_cb( int( stuff[ 0 ] ), int( stuff[ 1 ] ) )
				data = s.recv( 1024 )
			s.close( )
		except Exception, e:
			print e

def main( ):
	sys.argv.pop( 0 )
	if len( sys.argv ) > 0:
		print execute( sys.argv )
	else:
		print "Usage: jbatch_client.py commands ..."

if __name__ == "__main__":
	main( )

